/*	Filename:Code.cpp							*/
/************************************************/
/*												*/
/*					DELTA SOFT					*/
/*												*/
/*					Ver.1.00  					*/
/*												*/
/*	 			R[hϊW[			*/
/*                             					*/
/*			Copyright 2001 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#pragma	inline

#include	<mbstring.h>
#pragma hdrstop

#include "Code.h"

#pragma package(smart_init)

#define	then
#define	AND	&&
#define	OR	||

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****	SJISJIS	*****/

int	SJIStoJIS(int Code)
{
asm {
	xor	eax,eax;
	mov	ax,word ptr Code;
	or	ah,ah;
	jz	L9;

	shl	ah,1;
	sub	al,0x1F;
	js	L11;
	cmp	al,0x61;
	adc	al,0xDE;
}
L11:
asm {
	add	ax,0x1FA1;
	and	ax,0x7F7F;
}
L9:
	return(_EAX);
}

/*****	JISSJIS	*****/

int	JIStoSJIS(int Code)
{
asm {
	xor	eax,eax;
	mov	ax,word ptr Code;
	or	ah,ah;
	jz	L9;

	add	ax,0xA17E;
	shr	ah,1;
	jb	L11;
	cmp	al,0xDE;
	sbb	al,0x5E;
}
L11:
asm {
	xor	ah,0xE0;
}
L9:
	return(_EAX);
}

/*****	JISEUC	*****/
/*
	⏕͔T|[g
*/
int	JIStoEUC(int Code)
{
asm {
	xor	eax,eax;
	mov	ax,word ptr Code;
	or	ah,ah
	jz	L2;
	or	al,0x80;
	or	ah,0x80;
	jmp	L9;
}
L2:
asm {
	cmp	al,0xA1;
	jb	L9;
	cmp	al,0xE0;
	jnb	L9;
	mov	ah,0x8E;
}
L9:
	return(_EAX);
}

/*****  EUCJIS	*****/
/*
	⏕͔T|[g
*/
int	EUCtoJIS(int Code)
{
asm {
	xor	eax,eax;
	mov	ax,word ptr Code;
	or	ah,ah;
	jz	L9;
	cmp	ah,0x8E;										//p
	jnz	L2;
	xor	ah,ah;
	jmp	L9;
}
L2:
asm {
	and	al,0x7F;
	and	ah,0x7F;
}
L9:
	return(_EAX);
}

/*****	SJISEUC	*****/

int	SJIStoEUC(int Code)
{
	return(JIStoEUC(SJIStoJIS(Code)));
}

/*****	EUCSJIS	*****/

int	EUCtoSJIS(int Code)
{
	return(JIStoSJIS(EUCtoJIS(Code)));
}

/*****	JISSJIS	*****/

AnsiString	JIStoSJIS(AnsiString S)
{
	AnsiString	Res;
	int		c,i;
	char	bf[128];
	bool	f=false;
	unsigned char	*p=S.c_str();

	i=0;
	while(*p)
	{
		c=*p++;
		if (c==0x1B)
		then {
			c=*p++;
			if (c=='$')
			then {
				switch(*p++)
				{
					case '@':
					case 'B':
					case 'D':
						f=true;
						break;
				}
			}
			else if ((c=='&') AND (*(p+1)=='@'))
			then {
				f=true;
				p++;
				continue;
			}
			else if (c=='(')
			then {
				switch(*p++)
				{
					case 'B':
					case 'J':
					case 'I':
						f=false;
						break;
				}
			}
			continue;
		}
		if (f)
		then	c=(c<<8) | (*p++);
		c=JIStoSJIS(c);
		if (c & 0xFF00)
		then	bf[i++]=(c>>8) & 0xFF;
		bf[i++]=c & 0xFF;

		if (i>=126)
		then {
			bf[i]=0;
			Res+=bf;
			i=0;
		}
	}
	if (i)
	then {
		bf[i]=0;
		Res+=bf;
	}

	return(Res);
}

/*****	JISEUC	*****/

AnsiString	JIStoEUC(AnsiString S)
{
	AnsiString	Res;
	int		c,i;
	char	bf[128];
	bool	f=false;
	unsigned char	*p=S.c_str();

	i=0;
	while(*p)
	{
		c=*p++;
		if (c==0x1B)
		then {
			c=*p++;
			if (c=='$')
			then {
				switch(*p++)
				{
					case '@':
					case 'B':
					case 'D':
						f=true;
						break;
				}
			}
			else if ((c=='&') AND (*(p+1)=='@'))
			then {
				f=true;
				p++;
				continue;
			}
			else if (c=='(')
			then {
				switch(*p++)
				{
					case 'B':
					case 'J':
					case 'I':
						f=false;
						break;
				}
			}
			continue;
		}
		if (f)
		then	c=(c<<8) | (*p++);
		c=JIStoEUC(c);
		if (c & 0xFF00)
		then	bf[i++]=(c>>8) & 0xFF;
		bf[i++]=c & 0xFF;

		if (i>=126)
		then {
			bf[i]=0;
			Res+=bf;
			i=0;
		}
	}
	if (i)
	then {
		bf[i]=0;
		Res+=bf;
	}

	return(Res);
}

/*****	SJISEUC	*****/

AnsiString	SJIStoEUC(AnsiString S)
{
	AnsiString	Res;
	int		c,i;
	char	bf[128];
	unsigned char	*p=S.c_str();

	i=0;
	while(*p)
	{
		c=*p++;
		if (((c>=0x81) AND (c<=0x9F)) OR ((c>=0xE0) AND (c<=0xFC)))
		then	c=(c<<8) | (*p++);
		c=SJIStoEUC(c);
		if (c & 0xFF00)
		then	bf[i++]=(c>>8) & 0xFF;
		bf[i++]=c & 0xFF;

		if (i>=126)
		then {
			bf[i]=0;
			Res+=bf;
			i=0;
		}
	}
	if (i)
	then {
		bf[i]=0;
		Res+=bf;
	}

	return(Res);
}

/*****	EUCSJIS	*****/

AnsiString	EUCtoSJIS(AnsiString S)
{
	AnsiString	Res;
	int		c,i;
	char	bf[128];
	unsigned char	*p=S.c_str();

	i=0;
	while(*p)
	{
		c=*p++;
		if (c & 0x80)
		then	c=(c<<8) | (*p++);
		c=EUCtoSJIS(c);
		if (c & 0xFF00)
		then	bf[i++]=(c>>8) & 0xFF;
		bf[i++]=c & 0xFF;

		if (i>=126)
		then {
			bf[i]=0;
			Res+=bf;
			i=0;
		}
	}
	if (i)
	then {
		bf[i]=0;
		Res+=bf;
	}

	return(Res);
}

/*****	pSpϊ	*****/

AnsiString	HanToZen(AnsiString S)
{
	char		*p;
	int			len=S.Length();

	p=new char[(len+1)*2];

	LCMapString(GetUserDefaultLCID(),LCMAP_FULLWIDTH,S.c_str(),len,p,(len+1)*2);
	S=p;

	delete	p;

	return(S);
}

/*****	Sppϊ	*****/

AnsiString	ZenToHan(AnsiString S)
{
	int	len=S.Length();

	char	*p=new char[len+1];

	LCMapString(GetUserDefaultLCID(),LCMAP_HALFWIDTH,S.c_str(),len,p,len+1);
	S=p;

	delete	p;

	return(S);
}

/*****	End	*****/
