/*	Filename:HTML.CPP							*/
/************************************************/
/*												*/
/*			DSMP Lyrics Converter				*/
/*												*/
/*					Ver.6.00  					*/
/*												*/
/*	 			HTMLNXW[			*/
/*                             					*/
/*		Copyright 1998-2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <FileCtrl.hpp>
#include <shlobj.hpp>
#pragma hdrstop

//#include "project.h"
#include "html.h"
#include "Code.h"

#pragma package(smart_init)

#define	then
#define	AND	&&
#define	OR	||

/*----------------------------------------------*/
/*				dsvHtmlNX	 				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	dsvHtml::dsvHtml(void)
:TObject()
{
	FFile=NULL;
	FEmptySpace=false;
	FBGColor=clNone;

	FGenerator=ChangeFileExt(ExtractFileName(Application->ExeName),"");
	FGenerator+=FormatFloat(" ##.000",(double)Version/1000.0);
}

/*****	RXgN^	*****/

__fastcall	dsvHtml::dsvHtml(AnsiString FileName,Word Mode)
:TObject()
{
	FFileName=FileName;

	if (Mode==fmOpenRead)
	then	GetCodeSet();

	Open(Mode);
}

/*****	fXgN^	*****/

__fastcall	dsvHtml::~dsvHtml()
{
	Close();
}

/*****	t@C̐ݒ	*****/

void __fastcall	dsvHtml::SetFileName(AnsiString S)
{
	FFileName=S;
	FTitle="";
	if (FCodeSet != csUnknown)
	then	FPreCodeSet=FCodeSet;
	FCodeSet=csUnknown;
}

/*****	nh̎擾	*****/

int __fastcall	dsvHtml::GetHandle(void)
{
	if (FFile)
	then	return(FFile->Handle);
	else	return(NULL);
}

/*****	|WV̎擾	*****/

int __fastcall	dsvHtml::GetPosition(void)
{
	if (FFile)
	then	return(FFile->Position);
	else	return(0);
}

/*****	Open	*****/

void __fastcall	dsvHtml::Open(Word Mode)
{
	Close();
	if (FileExists(FileName))
	then	FFile=new TFileStream(FileName,(Word)(Mode | fmShareDenyNone));
	else {
		if (Mode != fmOpenRead)
		then	FFile=new TFileStream(FileName,(Word)(fmCreate | fmShareDenyNone));
	}
}

/*****	Close	*****/

void __fastcall	dsvHtml::Close(void)
{
	if (FFile)
	then {
		delete	FFile;
		FFile=NULL;
	}
}

/*****	t@C̍Ōォ	*****/

bool __fastcall	dsvHtml::IsEof(void)
{
	if (FFile)
	then {
		if (FFile->Position<FFile->Size)
		then	return(false);
	}

	return(true);
}

/*****	Seek	*****/

int __fastcall	dsvHtml::Seek(int Pos)
{
	if (FFile)
	then	return(FFile->Seek(Pos,soFromBeginning));
	else	return(0);
}

/*****	t@C[hi^O/Bodyj	*****/

AnsiString __fastcall	dsvHtml::Read(void)
{
	AnsiString	S;
	int			c;
	unsigned char	c1,c2;
	int			fTag=0;
	int			fComment=0;
	bool		fString=false;
	bool		fKanji=false;
	int			i;
	char		bf[128];

	i=0;
	while(FFile->Read(&c1,1))
	{
		c=c1;
L1:
		switch(FCodeSet)
		{
			default:
				if ((c>=0x81) AND (c<=0x9F) AND (c !=0x8E) AND (c != 0x8F))
				then {
					FCodeSet=csSJIS;
					goto L1;
				}
				if ((c==0xFD) OR (c==0xFE))
				then {
					FCodeSet=csEUC;
					goto L1;
				}
				if (c==0x1B)
				then {
					FCodeSet=csJIS;
					goto L1;
				}
				if (((c>=0x81) AND (c<=0x9F))
					OR ((c>=0xE0) AND (c<=0xFC)))
				then {
					FFile->Read(&c2,1);
					c=(c<<8) | c2;
					if (c2<0xA1)
					then	FCodeSet=csSJIS;
					else if ((c2==0xFD) OR (c2==0xFE))
					then {
						FCodeSet=csEUC;
						c=EUCtoSJIS(c);
					}
					else if (FPreCodeSet==csEUC)
					then	c=EUCtoSJIS(c);
				}
				else if ((FPreCodeSet==csEUC) AND (c & 0x80))
				then {
					FFile->Read(&c2,1);
					if (c2<0xA1)
					then {
						FCodeSet=csSJIS;
						FFile->Seek(-1,soFromCurrent);
					}
					else {
						if ((c2==0xFD) OR (c2==0xFE))
						then	FCodeSet=csEUC;
						c=EUCtoSJIS((c<<8) | c2);
					}
				}
				break;
			case csSJIS:
				if (((c>=0x81) AND (c<=0x9F))
					OR ((c>=0xE0) AND (c<=0xFC)))
				then {
					FFile->Read(&c2,1);
					c=(c<<8) | c2;
				}
				break;
			case csJIS:
				if (c==0x1B)
				then {
					FFile->Read(&c1,1);
					if (c1=='$')
					then {
						FFile->Read(&c1,1);
						if ((c1=='@') OR (c1=='B') OR (c1=='D'))
						then	fKanji=true;
					}
					else if (c1=='&')
					then {
						FFile->Read(&c1,1);
						if (c1=='@')
						then	fKanji=true;
					}
					else if (c1=='(')
					then {
						FFile->Read(&c1,1);
						if ((c1=='J') OR (c1=='B') OR (c1=='I'))
						then	fKanji=false;
					}
					continue;
				}
				if (fKanji)
				then {
					FFile->Read(&c2,1);
					c=JIStoSJIS((c<<8) | c2);
				}
				break;
			case csEUC:
				if (c & 0x80)
				then {
					FFile->Read(&c2,1);
					c=EUCtoSJIS((c<<8) | c2);
				}
				break;
		}

		if (c==0x0D)
		then {
			c=0x20;
			FFile->Read(&c2,1);
			if (c2 != 0x0A)
			then	FFile->Seek(-1,soFromCurrent);
		}
		if (c==0x0A)
		then	c=0x20;

		if (fString==false)
		then {
			if (c=='\"')
			then	fString=true;
			else if (c=='<')
			then {
				if (i)
				then {
					bf[i]=0;
					S+=bf;
					i=0;
				}
				if ((fComment==0) AND (!S.IsEmpty()))
				then {
					FFile->Seek(-1,soFromCurrent);
					break;
				}
				if (fComment==0)
				then	fTag++;
				FFile->Read(&c1,1);
				if (c1=='!')
				then {
					FFile->Read(&c1,1);
					FFile->Read(&c2,1);
					if ((c1=='-') AND (c2=='-'))
					then {
						fComment++;
						S+="<!--";
						continue;
					}
					else	FFile->Seek(-3,soFromCurrent);
				}
				else	FFile->Seek(-1,soFromCurrent);
			}
		}

		if (c & 0xFF00)
		then	bf[i++]=(c>>8) & 0xFF;
		bf[i++]=c & 0xFF;

		if (i>=125)
		then {
			bf[i]=0;
			S+=bf;
			i=0;
		}
		if (fString==false)
		then {
			if ((fComment) AND (c=='-'))
			then {
				FFile->Read(&c1,1);
				FFile->Read(&c2,1);
				if ((c1=='-') AND (c2=='>'))
				then {
					bf[i++]=c1;
					bf[i++]=c2;
					fComment--;
					c='>';
				}
				else	FFile->Seek(-2,soFromCurrent);
			}
			if ((fComment==0) AND (c=='>'))
			then {
				fTag--;
				if (fTag==0)
				then	break;
			}
		}
		else if ((fString==true) AND (c=='\"'))
		then	fString=false;
	}
	if (i)
	then {
		bf[i]=0;
		S+=bf;
	}
	return(S);
}

/*****	t@C[hiGeBeBϊj	*****/

AnsiString __fastcall	dsvHtml::Reads(void)
{
	AnsiString	S=Read();
	if (S=="@")
	then	S="";
	else {
		S=ExpandNameEntity(S);
		S=S.Trim();
	}

	return(S);
}

/*****	Write	*****/
/*
void __fastcall	dsvHtml::Write(AnsiString S)
{
	int		n=1;
	char	lf[2];
	lf[0]=0x0D;
	lf[1]=0x0A;

	while(n)
	{
		n=S.AnsiPos("\n");
		if (n)
		then {
			if (n>1)
			then	FFile->Write(S.c_str(),n-1);
			FFile->Write(lf,2);
			if (S.Length()-n>0)
			then	S=S.SubString(n+1,S.Length()-n);
			else	S="";
		}
	}
	if (!S.IsEmpty())
	then	FFile->Write(S.c_str(),S.Length());
}
*/
/*****	Write	*****/

void __fastcall	dsvHtml::Write(AnsiString S)
{
	S=StringReplace(S,"\t","    ",TReplaceFlags()<<rfReplaceAll);
	S=StringReplace(S,"\r","",TReplaceFlags()<<rfReplaceAll);
	S=StringReplace(S,"\n","\r\n",TReplaceFlags()<<rfReplaceAll);
	FFile->Write(S.c_str(),S.Length());
}

/*****	WriteiGeBeBϊj	*****/

void __fastcall	dsvHtml::Writes(AnsiString S)
{
	S=ConvertNameEntity(S);
	if ((FEmptySpace) AND (S.IsEmpty()))
	then	S="@";									//ȂSpXy[X
	Write(S);
}

/*****	Write Tab	*****/

void __fastcall	dsvHtml::WriteTab(int n)
{
	if (n==0)
	then	return;

	AnsiString	S=AnsiString::StringOfChar('\t',n);
	FFile->Write(S.c_str(),S.Length());
}

/*****	[h	*****/

void __fastcall	dsvHtml::Load(AnsiString FileName,TStringList *SList)
{
	SetFileName(FileName);

	SList->Clear();

	GetCodeSet();
	Open(fmOpenRead);

	while(IsEof()==false)
	{
		SList->Add(Read());
	}

	Close();
}

/*****	Z[u	*****/

void __fastcall	dsvHtml::Save(AnsiString FileName,TStringList *SList)
{
	AnsiString	S,s;
	int			i,j;
	int			Len=0;

	FFileName=FileName;

	Open(fmCreate);
	for(i=0;	i<SList->Count;	i++)
	{
		S=SList->Strings[i];
		S=S.Trim();
		Len+=S.Length();

		s=S.LowerCase();
		s=s.Trim();
		if ((s=="<html>") OR (s=="</html>")
			OR (s=="<head>") OR (s=="</head>")
			OR (s.AnsiPos("<body")==1) OR (s=="</body>")
			OR (s=="<br>") OR (s=="<hr>")
			OR (s=="<tr>") OR (s=="</tr>")
			OR (s=="</th>") OR (s=="</td>")
			OR (s=="</p>") OR (s=="</title>") OR (s=="</div>")
			OR (s=="</h1>") OR (s=="</h2>") OR (s=="</h3>")
			OR (s=="</h4>") OR (s=="</h5>") OR (s=="</h6>")
			OR (s.AnsiPos("<meta")==1)
			OR (s.AnsiPos("<table")==1) OR (s=="</table>")
			OR ((s.AnsiPos("</")==1) AND (Len>=60))
			OR (Len>=90))
		then {
			S+="\n";
			Len=0;
		}
		if ((s.AnsiPos("<table")==1) OR (s=="<li>"))
		then	S="\n"+S;

		Write(S);
	}
	Close();
}

/*****	eLXgt@CŃZ[u	*****/

void __fastcall	dsvHtml::SaveText(AnsiString FileName,TStringList *SList)
{
	AnsiString	Text;
	AnsiString	S,s;
	int			i;
	int			OLct=0;
	int			Tabct=0;
	bool		FBody=false;

	Close();

	FFile=new TFileStream(FileName,(Word)(fmCreate | fmShareDenyNone));

	for(i=0;	i<SList->Count;	i++)
	{
		S=SList->Strings[i];
		S=S.Trim();

		if (S.IsEmpty())
		then	continue;

		s=S.LowerCase();

		if (s=="</body>")
		then {
			FBody=false;
			continue;
		}

		if (s.AnsiPos("<body"))
		then {
			FBody=true;
		}
		if (FBody==false)
		then	continue;

		if ((s=="<br>") OR (s=="</p>") OR (s=="</th>") OR (s=="</tr>")
			OR (s=="</ul>") OR (s=="</ol>"))
		then {
			Text+="\r\n";
			FFile->Write(Text.c_str(),Text.Length());
			Text="";
			if (s=="</ol>")
			then	OLct=0;
		}
		else if (s.AnsiPos("<li"))
		then {
			if (!Text.IsEmpty())
			then {
				Text+="\r\n";
				FFile->Write(Text.c_str(),Text.Length());
			}
			if (OLct)
			then {
				Text+=OLct++;
			}
			else {
				if (s.AnsiPos("circle"))
				then	Text="";
				else if (s.AnsiPos("square"))
				then	Text="";
				else	Text="E";
			}
		}
		else if (s.AnsiPos("<ol"))
		then {
			OLct=1;
		}
		else if (s=="<blockquote>")
		then {
			Tabct++;
		}
		else if (s=="</blockquote>")
		then {
			Tabct--;
			if (Tabct<0)
			then	Tabct=0;
		}
		else if (S[1]=='<')
		then	continue;
		else {
			if ((Text.IsEmpty()) AND (Tabct))
			then	WriteTab(Tabct);
			Text+=S;
		}
	}
	if (!Text.IsEmpty())
	then {
		Text+="\r\n";
		FFile->Write(Text.c_str(),Text.Length());
	}
	
	Close();
}

/*****	Htmlt@C̍쐬	*****/

void __fastcall	dsvHtml::MakeHeader(void)
{
	AnsiString	S;

	if (FFile)
	then	Close();

	Open(fmCreate);
	if (FFile==NULL)
	then	return;

	Write("<html>\n");
	Write("<head>\n");
	Write("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n");
	S="<meta name=\"GENERATOR\" content=\"";
	S+=FGenerator;
	S+="\">\n";
	Write(S);
	Write("<title>");
	Write(FTitle);
	Write("</title>\n");
	Write("</head>\n");
	if (!FBackGround.IsEmpty())
	then {
		AnsiString	S="<body background=\"";
		S+=FBackGround;
		S+="\">\n";
		Write(S);
	}
	else if (FBGColor != clNone)
	then {
		AnsiString	S="<body bgcolor=\"#";
		S+=IntToHex(FBGColor,4);
		S+="\">\n";
		Write(S);
	}

	else	Write("<body>\n");
}

/*****	HTMLt@C̃N[Y	*****/

void __fastcall	dsvHtml::MakeEnd(void)
{
	if (FFile)
	then {
		Write("</body>\n");
		Write("</html>\n");
		Close();
	}
}

/*****	HTMLt@C	*****/

void __fastcall	dsvHtml::MakeHTML(void)
{
	AnsiString	S=ExtractFileDir(FileName);
	if (DirectoryExists(S)==false)
	then	ForceDirectories(S);

	MakeHeader();
	MakeEnd();
}

/*****	l[GeBeBϊ	******/

AnsiString __fastcall	dsvHtml::ExpandNameEntity(AnsiString S)
{
	S=StringReplace(S,"&amp;","&",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
	S=StringReplace(S,"&nbsp;"," ",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
	S=StringReplace(S,"&quot;","\"",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
	S=StringReplace(S,"&lt;","<",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
	S=StringReplace(S,"&gt;",">",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);

	int			d,i,n;
	AnsiString	s;

	while((n=S.AnsiPos("&#")) !=0)
	{
		for(i=n+2;	i<S.Length();	i++)
		{
			if (S[i]==';')
			then {
				s=S.SubString(n,i-n-2);
				d=s.ToIntDef(-1);
				if (d<0)
				then	break;

				S[n]=(char)d;
				s=S.SubString(i+1,S.Length()-n+1);
				S=S.SubString(1,n);
				S+=s;
			}
		}

	}
	return(S);
}

/*****	l[GeBeBɕϊ	******/

AnsiString __fastcall	dsvHtml::ConvertNameEntity(AnsiString S)
{
	S=StringReplace(S,"&","&amp;",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
	S=StringReplace(S," ","&nbsp;",TReplaceFlags()<<rfReplaceAll);
	S=StringReplace(S,"\"","&quot;",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
	S=StringReplace(S,"<","&lt;",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
	S=StringReplace(S,">","&gt;",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);

	return(S);
}

/*****	R[h^Cv̎擾	*****/

TCodeSet __fastcall	dsvHtml::GetCodeSet(void)
{
	AnsiString	s,S;
	int			n;

	if (FCodeSet==csUnknown)
	then {
		FPreCodeSet=csEUC;

		Open(fmOpenRead);

		while(IsEof()==false)
		{
			S=Read();
			if (S.IsEmpty())
			then	break;
			if (S[1]=='<')
			then {
				s=S.LowerCase();
				if (s.AnsiPos("<meta"))
				then {
					n=s.AnsiPos("charset");
					s=s.SubString(7,s.Length()-n);
					if ((s.AnsiPos("shift_jis"))
						OR (s.AnsiPos("x-sjis")))
					then	FCodeSet=csSJIS;
					else if (s.AnsiPos("euc-jp"))
					then	FCodeSet=csEUC;
					else if (s.AnsiPos("iso-2022-jp"))
					then	FCodeSet=csJIS;
				}
			}
			if (FCodeSet != csUnknown)
			then	break;
		}
		Close();
		if (FCodeSet==csUnknown)
		then	FCodeSet=csEUC;
	}

	return(FCodeSet);
}

/*****	^Cg̎擾	*****/

AnsiString __fastcall	dsvHtml::GetTitle(void)
{
	AnsiString	S;
	AnsiString	s;
	bool		f;
	int			n;

	if (!FTitle.IsEmpty())
	then	return(FTitle);

	if (FileName.IsEmpty())
	then	return("");

	if (FileExists(FileName)==false)
	then	return("");

	GetCodeSet();
	Open(fmOpenRead);

	while(IsEof()==false)
	{
		S=Read();
		if (S.IsEmpty())
		then	break;
		S=S.Trim();
		if (S.IsEmpty())
		then	continue;

		if (S[1]=='<')
		then {
			s=S.LowerCase();
			if (s=="<title>")
			then	f=true;
			else if (s=="</title>")
			then	break;
		}
		else if (f)
		then {
			FTitle=S;
			break;
		}
	}
	Close();

	return(FTitle);
}

/*****	N̎擾Tu	*****/

AnsiString __fastcall	dsvHtml::GetTarget(AnsiString S,AnsiString Key)
{
	AnsiString	Link;
	int			i,n;
	int			len=S.Length();

	AnsiString	s=S.LowerCase();
	n=s.AnsiPos(Key);
	if (n==0)
	then	return(Link);

	for(n+=Key.Length();	n<=len;	n++)
	{
		if (S[n]=='=')
		then	break;
	}
	n++;
	if (n>len)
	then	return(Link);

	for(;	n<=len;	n++)
	{
		if (S[n]=='\"')
		then	continue;
		if (S[n] != ' ')
		then	break;
	}
	for(i=n;	n<=len;	n++)
	{
		if (S[n]=='\"')
		then	break;
	}
	n=n-i;
	if (n)
	then	Link=S.SubString(i,n);

	return(Link);
}

/*****	N̎擾	*****/

void __fastcall	dsvHtml::GetLink(TStringList *SList)
{
	AnsiString	S;
	AnsiString	Link;

	SList->Clear();

	if (FileName.IsEmpty())
	then	return;

	if (FileExists(FileName)==false)
	then	return;

	GetCodeSet();
	Open(fmOpenRead);

	while(IsEof()==false)
	{
		S=Reads();
		S=S.Trim();
		if ((S.IsEmpty()) OR (S[1] !='<'))
		then	continue;

		Link=GetTarget(S,"dynsrc");
		if (Link.IsEmpty())
		then {
			Link=GetTarget(S,"src");
			if (Link.IsEmpty())
			then {
				Link=GetTarget(S,"href");
				if (Link.IsEmpty())
				then {
					Link=GetTarget(S,"background");
					if (Link.IsEmpty())
					then {
						Link=GetTarget(S,"action");
						if (Link.IsEmpty())
						then	continue;
					}
				}
			}
		}
		if (SList->IndexOf(Link)<0)
		then	SList->Add(Link);
	}

	Close();
}

/*****	Edit	*****/

void __fastcall	dsvHtml::Edit(void)
{
	AnsiString	S;

	if (Editor.IsEmpty())
	then	return;

	Close();

	if (FileExists(FileName)==false)
	then	MakeHTML();
/*
	S="\""+Editor;
	S+="\" \"";
	S+=FileName;
	S+="\"";
	ExecProcess(Editor,S,"",SW_SHOWNORMAL,0,NULL);
*/
//	S=ExtractFileDir(FileName);
	if (FEditor.IsEmpty())
	then	::ShellExecute(Application->Handle,"edit",FileName.c_str(),NULL,NULL,SW_SHOWNORMAL);
	else	::ShellExecute(Application->Handle,"open",Editor.c_str(),FileName.c_str(),NULL,SW_SHOWNORMAL);

}

/*****	R[hϊ	*****/

void __fastcall	dsvHtml::ConvertCode(TCodeSet NewCode,AnsiString Path)
{
	AnsiString	S,s;
	int			i,j,n;
	bool		f;
	AnsiString	New;

	switch(NewCode)
	{
		case csSJIS:
			New="Shift_JIS";
			break;
		case csEUC:
			New="euc-jp";
			break;
		case csJIS:
			New="iso-2022-jp";
			break;
	}

	TStringList	*SList=new TStringList();

	Open(fmOpenRead);
	while(IsEof()==false)
	{
		SList->Add(Read());
	}
	Close();

	AnsiString	CharSet="<meta http-equiv=\"Content-Type\" content=\"text/html; charset=";
	CharSet+=New;
	CharSet+="\">";
	f=false;
	for(i=0;	i<SList->Count;	i++)
	{
		S=SList->Strings[i];
		s=S.LowerCase();
		if ((s.AnsiPos("<meta")==1)
			AND(s.AnsiPos("content-type")) AND (s.AnsiPos("charset=")))
		then {
			SList->Strings[i]=CharSet;
			S=CharSet;
			f=true;
		}
		if ((f==false) AND (s=="</head>"))
		then {
			SList->Insert(i,CharSet);
			S=CharSet;
			f=true;
		}

		if (NewCode==csEUC)
		then	SList->Strings[i]=SJIStoEUC(S);
	}

	Save(Path,SList);

	delete	SList;
}

/*****	End	*****/

