/*	Filename:Download.h							*/
/************************************************/
/*												*/
/*			DSMP Lyrics Converter				*/
/*												*/
/*			DSMP̎t@Cϊc[			*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			C^[lbgW[			*/
/*                             					*/
/*		Copyright 1999,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

#ifndef inetH
#define inetH

#include	<wininet.h>

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

enum	TBrowserType	{btIE, btNN};
enum	TDownloadStatus	{dsSuspended,dsConnecting,dsDownloading,dsDisconnecting,dsDownloaded,dsDownloadFailed};

typedef void __fastcall (__closure *TDownloadProgress)(System::TObject* Sender,TDownloadStatus Status,DWORD Size);

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

bool __fastcall	OpenURL(AnsiString URL);
bool __fastcall	JumpURL(AnsiString URL);
AnsiString	GetBrowserURL(TBrowserType BrowserType=btIE);
AnsiString __fastcall	ExtractURL(AnsiString URL);

/*----------------------------------------------*/
/*				TWinInetNX	 				*/
/*----------------------------------------------*/

class	TWinInet:public TObject
{
private:
	HINTERNET 			FSession;
	HINTERNET 			FHandle;
	HANDLE				FMutex;
	bool				FOffline;
	bool				FAborted;
	AnsiString			FURL;
	bool				FWriteCache;
	DWORD				FError;
	TDownloadProgress	FOnProgress;

protected:
public:
	__fastcall	TWinInet(void);
	__fastcall	~TWinInet(void);
	bool __fastcall	Open(void);
	void __fastcall	Close(void);
	bool __fastcall	CanConnect(void);
	bool __fastcall	Connect(AnsiString URL);
	void __fastcall	Disconnect(void);
	int __fastcall	Read(char *bf,int Size);
	bool __fastcall	Download(AnsiString Url,AnsiString Path);

	__property	HINTERNET	Session={read=FSession};
	__property	HINTERNET	Handle={read=FHandle};
	__property	AnsiString	URL={read=FURL};
	__property	bool		Offline={read=FOffline,write=FOffline};
	__property	bool		Aborted={read=FAborted,write=FAborted};
	__property	bool		WriteCache={read=FWriteCache,write=FWriteCache};
	__property	DWORD		Error={read=FError,write=FError};
	__property	TDownloadProgress	OnProgress={read=FOnProgress,write=FOnProgress};
};

/*----------------------------------------------*/
/*			TDownloadThreadNX				*/
/*----------------------------------------------*/

class	TDownloadThread:public TThread
{
private:
	TWinInet*		FWinInet;
	AnsiString		FPath;
	AnsiString		FURL;
	bool			FWait;
	bool			FWaiting;
	TDownloadStatus	FStatus;
	TDownloadProgress	FOnProgress;

protected:
	void __fastcall	ProgressEvent(System::TObject* Sender,TDownloadStatus Status,DWORD Size);

public:
	__fastcall	TDownloadThread(void);
	__fastcall	~TDownloadThread(void);
	bool __fastcall	Download(AnsiString URL,AnsiString Path,bool Wait=true);
	bool __fastcall	Download(void);
	void __fastcall Execute(void);

	__property	TDownloadStatus	Status={read=FStatus,write=FStatus};
	__property	AnsiString		URL={read=FURL,write=FURL};
	__property	AnsiString		Path={read=FPath,write=FPath};
	__property	bool			Wait={read=FWait,write=FWait};
	__property	TDownloadProgress	OnProgress={read=FOnProgress,write=FOnProgress};
};

#endif

/*****	End	****/
